Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/INPUT_PORT_MODULE.vhd
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/INPUT_PORT_MODULE.vhd	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/INPUT_PORT_MODULE.vhd	(revision 65)
@@ -44,5 +44,5 @@
     Port ( data_in : in  STD_LOGIC_VECTOR (Word-1 downto 0);
            data_in_en : in  STD_LOGIC; -- signaler la présence des données en entrée
-			  cmd_in_en : STD_LOGIC;    --permet d'identifier les données qui sont dans le tampon
+			  cmd_in_en :in STD_LOGIC;    --permet d'identifier les données qui sont dans le tampon
            reset : in  STD_LOGIC;
 			  clk   : in  STD_LOGIC;
@@ -73,5 +73,5 @@
 
 --definition du type etat pour les fsm
-type fsm_states is (state0, CmdOn, WaitGrant, ReqPort, state1, state2,stpulse, state3);-- definition du type etat pour le codage des etats des fsm
+type fsm_states is (state0, CmdOn, WaitGrant, ReqPort, state1, state2,stpulse,stateErr, state3);-- definition du type etat pour le codage des etats des fsm
 type fsm_states2 is(cmdstart,cmdwait,cmdread,cmdSetDest,cmdSetCount,cmdSetId,cmdpulse,CmdEnd);
 signal pop_state : fsm_states;
@@ -79,9 +79,10 @@
 signal cmd_exec : std_logic:='0';  --indique que le port est en train d'exécuter une commande
 signal dat_exec :std_logic:='0'; -- indique le port est en train de transférer des données
-signal readOk : std_logic:='0'; --indique s'il est possible de lire les données
+signal dat_Err :std_logic:='0'; -- signal une erreur pendant l'exécution 
+signal readOk,CmdReadOk : std_logic:='0'; --indique s'il est possible de lire les données
 -- signaux utilisés dans les fsm
-signal request_decoder : STD_LOGIC_VECTOR(number_of_ports  downto 1);
+signal request_decoder,req_grant : STD_LOGIC_VECTOR(number_of_ports  downto 1);
 signal request_decoder_en : std_logic;
-signal request_latch : STD_LOGIC_VECTOR(4 downto 1);   -- pourquoi pas 3 downto 0 ?
+signal request_latch : STD_LOGIC_VECTOR(4 downto 1):=(others=>'0');   -- pourquoi pas 3 downto 0 ?
 signal request_latch_en : std_logic;
 signal pipeline_latch : std_logic_vector(Word-1 downto 0);
@@ -131,10 +132,11 @@
 
 data_out <= pipeline_latch ;--when cmd_exec='0' else cmd_data_signal;
-fifo_empty <= fifo_empty_signal;
+fifo_empty <= empty_latch;
 reset_signal <= reset;
 grant_proc:process(clk)
 begin
 if rising_edge(clk) then
-	if unsigned(grant)> 0 then
+--	if unsigned(grant)> 0 then
+	if unsigned(req_grant) > 0 then
 		port_granted <= '1';   		--il faut veiller à ce que ce port soit vraiment autorisé
 	else 
@@ -145,4 +147,8 @@
 rd_en_signal <= not(empty_latch) ;
 request <= request_decoder;
+reg_grant:process (request_decoder,grant)
+begin
+req_grant<=request_decoder and grant;
+end process reg_grant;
 request_word <=  request_latch & request_decoder_en;
 clk_signal <= clk;
@@ -499,5 +505,5 @@
 		  case pop_state is
 			when state0 => if cmd_in_en='0'  then --il ne faut pas exécuter les deux MAE ...
-									if fifo_empty_signal  ='0' then -- pile pas vide on doit dépiler									
+									if empty_latch  ='0' then -- pile pas vide on doit dépiler									
 										pop_state <= WaitGrant;
 									end if;
@@ -505,7 +511,14 @@
 									pop_state <= CmdOn;
 								end if;
-			when CmdOn => if fifo_empty_signal='1' then
+			when CmdOn => if empty_latch='1' and cmd_in_en='0' then
 								pop_state <= state0;
+								elsif empty_latch='0' and cmd_in_en='1' then
+								pop_state <= CmdOn;
+								elsif empty_latch='1' and cmd_in_en='1' then
+								pop_state <= state0;
+								else -- empty_latch='0' and cmd_in_en='0'
+								pop_state <= WaitGrant;
 								end if;
+								
 			when WaitGrant => if port_granted = '1' then
 										--
@@ -536,4 +549,8 @@
 										  pop_state <= state2;
 										  ReadOk<='1';
+										else --rd_en_signal='0' fin prématurée de la lecture
+											ReadOk<='0';
+											pop_state<=stateErr;
+											data_counter<=(others => '0');
 										end if;
 									else
@@ -549,5 +566,7 @@
 										data_counter <= data_counter - 1;
 										pop_state <= state0;
-																						
+			when stateErr => 	 
+										data_counter <= data_counter;
+										pop_state <= stateErr;												
 			when others => pop_state <= state0;
 		   end case;
@@ -557,5 +576,5 @@
 
 -- actions associées à chaque etat de la fsm de mealy
-pop_fsm_action : process(pop_state, fifo_out_signal,fifo_empty_signal, rd_en_signal,readok, port_granted )
+pop_fsm_action : process(pop_state, fifo_out_signal,empty_latch, rd_en_signal,readok, port_granted )
   begin   
 -- code fonctionnel	
@@ -568,7 +587,9 @@
 								dat_priority_rotation <= '1';
 								dat_exec<='0';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
+								
 		when CmdOn =>		dat_request_latch_en <= '0';  
-								dat_pipeline_latch_en <= rd_en_signal;
+								dat_pipeline_latch_en <= '0';
 								dat_fifo_read_signal <='0';
 								dat_request_decoder_en <= '0';
@@ -576,4 +597,5 @@
 								dat_priority_rotation <= '1';
 								dat_exec<='0';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
 		when WaitGrant =>	
@@ -585,13 +607,15 @@
 								dat_priority_rotation <= '0';
 								dat_exec<='1';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal(7 downto 4) & PORT_ID(3 downto 0);
 		when ReqPort =>	
 								dat_request_latch_en <='1'; --autoriser l'identification du port de destination
-								dat_pipeline_latch_en <= Port_granted; --pour le transmettre à travers le réseau
-								dat_fifo_read_signal <= Port_granted;
+								dat_pipeline_latch_en <= '1'; --pour le transmettre à travers le réseau
+								dat_fifo_read_signal <= '1';
 								dat_request_decoder_en <= '1';          --autoriser le decodeur activer le dernier bit de request
 								dat_data_out_pulse <= '0';     --transmettre le signal pour le dernier mot
 								dat_priority_rotation <= '0';
 								dat_exec<='1';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal(7 downto 4) & PORT_ID(3 downto 0);
 							
@@ -600,7 +624,8 @@
 								dat_fifo_read_signal <= rd_en_signal and port_granted;
 								dat_request_decoder_en <= '1';
-								dat_data_out_pulse <= '1';
+								dat_data_out_pulse <= port_granted;
 								dat_priority_rotation <= '0';
 								dat_exec<='1';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
 								
@@ -612,4 +637,5 @@
 								dat_priority_rotation <= '0';
 								dat_exec<='1';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
 								
@@ -621,4 +647,5 @@
 								dat_priority_rotation <= '0';
 								dat_exec<='1';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
 								
@@ -630,6 +657,15 @@
 								dat_data_out_pulse <= '0';
 								dat_exec<='0';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
-		
+		when stateErr =>    dat_request_latch_en <= '0';
+								dat_pipeline_latch_en <= '0';
+								dat_priority_rotation <= '1';    -- libérer la priorité
+								dat_fifo_read_signal <= '0';
+								dat_request_decoder_en <= '0';   --libérer le décodeur
+								dat_data_out_pulse <= '0';
+								dat_exec<='1';
+								dat_Err<='1';
+								push_dout<=fifo_out_signal;
 		when others =>    dat_request_latch_en <= '0';
 								dat_pipeline_latch_en <= '0';
@@ -639,4 +675,5 @@
 								dat_data_out_pulse <= '0';
 								dat_exec<='0';
+								dat_Err<='0';
 								push_dout<=fifo_out_signal;
 										
@@ -655,45 +692,57 @@
 	
 	   when cmdstart  =>
-				if cmd_in_en='1' and dat_exec='0' and fifo_empty_signal='0' then 
-				cmdstate<=cmdwait;
+				if cmd_in_en='1' and dat_exec='0' and empty_latch='0' then 
+				cmdstate<=cmdread;
 				end if;
-		when cmdwait => if fifo_empty_signal='0' and port_granted ='1' then
+				cmdReadOk<='0';
+		when cmdwait => if port_granted='1' then  -- demande du port de sortie
 								
-									cmdstate<=cmdread;
+									cmdstate<=cmdsetdest;
+							elsif cmd_in_en='1' then
+								cmdstate<=cmdwait;
 							else 
 								cmdstate<=cmdstart;
 							end if;
+							cmdReadOk<='0';
 		when cmdread =>
-				if port_granted ='1'then -- ne pas modifier l'état des priorités si on ne l'avait pas
+--				if port_granted ='1'then -- ne pas modifier l'état des priorités si on ne l'avait pas
 					cmdcode:= to_integer(unsigned(fifo_out_signal));
 					if cmdcode=1 then --code de getportid
-							cmdstate<=cmdsetdest;
+							cmdstate<=cmdwait;
+							cmdReadOk<='1';
 					else
-						if port_granted='1' then
-							cmdstate<=cmdend;
-						end if;
+						        --ne pas prendre le code inconnu en compte
+							cmdstate<=cmdend; -- la commande n'a pas été reconnu
+						
+						cmdReadOk<='0';
 					end if;
-				end if;
+--				end if;
 		when cmdsetdest =>
 				if port_granted='1' then
 					cmdstate<=cmdsetcount;
 				end if;
+				cmdReadOk<='0';
 		when cmdsetcount =>
 				if port_granted='1' then
 					cmdstate<=cmdsetID;
+				else
+					cmdstate<=cmdsetdest;
 				end if;
+				cmdReadOk<='0';
 		when cmdsetID=>
 			if port_granted='1' then
 			cmdstate <=cmdpulse;
 			end if;
+			cmdReadOk<='0';
 		when cmdpulse =>
 			if port_granted='1' then
 			cmdstate <=cmdEnd;
 			end if;
+			cmdReadOk<='0';
 		when cmdend  =>
-			
+			if cmd_in_en='0' then --éviter l'exécution en boucle
 				cmdstate<=cmdstart; 
-			
-				
+			end if;
+			cmdReadOk<='0';	
 	  
 	end case;
@@ -715,27 +764,27 @@
 						cmd_data_signal<=(others=>'0');
 						cmd_data_out_pulse <= '0';
-	when cmdwait =>
+
+	when cmdread =>
+						cmd_exec<='1';
+						cmd_pipeline_latch_en <= '0';
+						cmd_fifo_read_signal <= '1'; -- vider le tampon d'entrée
+						cmd_request_latch_en<='1';    --mémoriser l'adresse de destination
+						cmd_request_decoder_en <= '1';                   --demande d'émission
+						cmd_data_out_pulse <= '0';
+						cmd_priority_rotation <= '1';                    --sans priorité
+						cmd_data_signal<=Port_ID;  
+		when cmdwait =>
 						cmd_exec<='1';
 						cmd_pipeline_latch_en <='0';
 						cmd_fifo_read_signal <= '0';
-						cmd_priority_rotation <= '1';    --sans priorité
-						cmd_request_latch_en<='0';
-						cmd_request_decoder_en <= not(fifo_empty_signal);   --demande d'émission
-						cmd_data_signal<=(others=>'0');
-						cmd_data_out_pulse <= '0';
-	when cmdread =>
-						cmd_exec<='1';
-						cmd_pipeline_latch_en <= '1';
-						cmd_fifo_read_signal <= '0';
-						cmd_request_latch_en<='1';    --mémoriser l'adresse de destination
-						cmd_request_decoder_en <= '1';                   --demande d'émission
-						cmd_data_out_pulse <= '0';
-						cmd_priority_rotation <= '0';                    --avec priorité
-						--cmd_data_signal<=(others=>'0');
-						cmd_data_signal<=Port_ID;  
+						cmd_request_latch_en<='1';
+						cmd_priority_rotation <= '0';    --avec priorité
+						cmd_request_decoder_en <= '1';   --demande d'émission
+						cmd_data_signal<=Port_ID;
+						cmd_data_out_pulse <= '0';					
 	when cmdsetdest  =>
 						--cmd_request_decoder_en <= '1';
 						cmd_exec<='1';
-						cmd_pipeline_latch_en <='1';
+						cmd_pipeline_latch_en <='1'; --empiler dans le tampon de sortie la donnée
 						cmd_fifo_read_signal <='0';
 						cmd_request_latch_en<='0';
@@ -744,5 +793,14 @@
 						cmd_priority_rotation <= '0';
 						cmd_data_signal<=Port_ID;    -- le numéro du port et le nombre total des ports est envoyé
-						
+	when cmdsetcount =>
+								 
+						cmd_exec<='1';   
+						cmd_pipeline_latch_en <='1'; -- empiler dans le tampon de sortie les données
+						cmd_fifo_read_signal <='0';
+						cmd_request_latch_en<='0';  --enregistrer l'adresse de destination
+						cmd_request_decoder_en <= '1';          --autoriser le decodeur activer le dernier bit de request
+						cmd_data_out_pulse <= port_granted;
+						cmd_priority_rotation <= '0';
+						cmd_data_signal<=STD_LOGIC_VECTOR(to_unsigned(3,8));					
 	when cmdSetId =>
 						--cmd_request_decoder_en <= '1';
@@ -750,21 +808,10 @@
 						cmd_pipeline_latch_en <='1';
 						cmd_fifo_read_signal <='0';
-						cmd_request_latch_en<='0';
+						cmd_request_latch_en<='0';			--enregistrer l'adresse de destination
 						cmd_request_decoder_en <= '1';          --autoriser le decodeur à activer le dernier bit de request
-						cmd_data_out_pulse <= '1';
+						cmd_data_out_pulse <= port_granted;
 						cmd_priority_rotation <= '0';
 						cmd_data_signal<=Port_ID;    -- le numéro du port et le nombre total des ports est envoyé
 											
-	when cmdsetcount =>
-								 
-						cmd_exec<='1';   
-						cmd_pipeline_latch_en <='1';
-						cmd_fifo_read_signal <='1';
-						cmd_request_latch_en<='0';
-						cmd_request_decoder_en <= '1';          --autoriser le decodeur activer le dernier bit de request
-						cmd_data_out_pulse <= port_granted;
-						cmd_priority_rotation <= '0';
-						cmd_data_signal<=STD_LOGIC_VECTOR(to_unsigned(3,8));
-	
 	when cmdpulse =>	cmd_exec<='1';
 						cmd_pipeline_latch_en <='0';
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Proto_receiv.vhd
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Proto_receiv.vhd	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/Proto_receiv.vhd	(revision 65)
@@ -81,11 +81,15 @@
 								dlen:=to_integer(unsigned(fifo_out));
 								mem(1)<=fifo_out; -- la longueur
-								etrec<=r_data;
 								
+								if dlen>2 then
+									etrec<=r_data;
+								else
+									etrec<=r_end;
+								end if;
 								i:=1;
 								
 						when r_data  =>
 								if fifo_empty='0' then
-									if i<dlen-3 then
+									if i<dlen-2 then
 										i:=i+1;
 										mem(i)<=fifo_out;
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER12_12.VHD
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER12_12.VHD	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER12_12.VHD	(revision 65)
@@ -55,9 +55,10 @@
  signal grant_latch : std_logic_vector(144 downto 1); 
  signal priority_rotation_en : std_logic; 
- signal Grant :  std_logic_vector(144 downto 1);
+ signal Grant,req_grant :  std_logic_vector(144 downto 1);
  begin
 
 --validation de la rotation de priorité lorsque aucun port n'emet 
- priority_rotation_en <= '1' when unsigned(priority_rotation) = 4095 else 	'0'; 
+req_grant<=(request and grant_latch);
+ priority_rotation_en <= '1' when unsigned(req_grant) = 0 or unsigned(priority_rotation) = 4095 else 	'0'; 
 --latch servant qui memorise le signal grant pendant a transmission 
 grant_latch_process : process(clk)
@@ -66,10 +67,10 @@
    if reset = '1' then 
  		grant_latch <= (others => '0'); 
- 	 elsif priority_rotation_en = '1' then 
+ 	 elsif  priority_rotation_en = '1' or unsigned(Grant_latch)=0 then 
 	   grant_latch <= Grant; 
    end if; 
    end if; 
  end process; 
- port_grant <= Grant and grant_latch; 
+ port_grant <= grant_latch; 
  Grant(1)  <= Signal_grant(1)(1) or Signal_grant(13)(1); --  Grant(1,1)
 Grant(2)  <= Signal_grant(2)(2) or Signal_grant(14)(2); --  Grant(1,2)
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER13_13.VHD
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER13_13.VHD	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER13_13.VHD	(revision 65)
@@ -55,9 +55,10 @@
  signal grant_latch : std_logic_vector(169 downto 1); 
  signal priority_rotation_en : std_logic; 
- signal Grant :  std_logic_vector(169 downto 1);
+ signal Grant,req_grant :  std_logic_vector(169 downto 1);
  begin
 
 --validation de la rotation de priorité lorsque aucun port n'emet 
- priority_rotation_en <= '1' when unsigned(priority_rotation) = 8191 else 	'0'; 
+req_grant<=(request and grant_latch);
+ priority_rotation_en <= '1' when unsigned(req_grant) = 0 or unsigned(priority_rotation) = 8191 else 	'0'; 
 --latch servant qui memorise le signal grant pendant a transmission 
 grant_latch_process : process(clk)
@@ -66,10 +67,10 @@
    if reset = '1' then 
  		grant_latch <= (others => '0'); 
- 	 elsif priority_rotation_en = '1' then 
+ 	 elsif priority_rotation_en = '1' or unsigned(Grant_latch)=0 then 
 	   grant_latch <= Grant; 
    end if; 
    end if; 
  end process; 
- port_grant <= Grant and grant_latch; 
+ port_grant <= grant_latch; 
  Grant(1)  <= Signal_grant(1)(1) or Signal_grant(14)(1); --  Grant(1,1)
 Grant(2)  <= Signal_grant(2)(2) or Signal_grant(15)(2); --  Grant(1,2)
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER14_14.VHD
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER14_14.VHD	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER14_14.VHD	(revision 65)
@@ -55,9 +55,10 @@
  signal grant_latch : std_logic_vector(196 downto 1); 
  signal priority_rotation_en : std_logic; 
- signal Grant :  std_logic_vector(196 downto 1);
+ signal Grant,req_grant :  std_logic_vector(196 downto 1);
  begin
 
 --validation de la rotation de priorité lorsque aucun port n'emet 
- priority_rotation_en <= '1' when unsigned(priority_rotation) = 16383 else 	'0'; 
+req_grant<=(request and grant_latch);
+ priority_rotation_en <= '1' when unsigned(req_grant) = 0 or unsigned(priority_rotation) = 16383 else 	'0'; 
 --latch servant qui memorise le signal grant pendant a transmission 
 grant_latch_process : process(clk)
@@ -66,10 +67,10 @@
    if reset = '1' then 
  		grant_latch <= (others => '0'); 
- 	 elsif priority_rotation_en = '1' then 
+ 	 elsif priority_rotation_en = '1' or unsigned(Grant_latch)=0 then 
 	   grant_latch <= Grant; 
    end if; 
    end if; 
  end process; 
- port_grant <= Grant and grant_latch; 
+ port_grant <= grant_latch; 
  Grant(1)  <= Signal_grant(1)(1) or Signal_grant(15)(1); --  Grant(1,1)
 Grant(2)  <= Signal_grant(2)(2) or Signal_grant(16)(2); --  Grant(1,2)
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER15_15.VHD
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER15_15.VHD	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER15_15.VHD	(revision 65)
@@ -55,9 +55,10 @@
  signal grant_latch : std_logic_vector(225 downto 1); 
  signal priority_rotation_en : std_logic; 
- signal Grant :  std_logic_vector(225 downto 1);
+ signal Grant ,req_grant:  std_logic_vector(225 downto 1);
  begin
 
 --validation de la rotation de priorité lorsque aucun port n'emet 
- priority_rotation_en <= '1' when unsigned(priority_rotation) = 32767 else 	'0'; 
+req_grant<=(request and grant_latch);
+ priority_rotation_en <= '1' when unsigned(req_grant)=0 or unsigned(priority_rotation) = 32767 else 	'0'; 
 --latch servant qui memorise le signal grant pendant a transmission 
 grant_latch_process : process(clk)
@@ -66,10 +67,10 @@
    if reset = '1' then 
  		grant_latch <= (others => '0'); 
- 	 elsif priority_rotation_en = '1' then 
+ 	 elsif priority_rotation_en = '1'or unsigned(Grant_latch)=0 then 
 	   grant_latch <= Grant; 
    end if; 
    end if; 
  end process; 
- port_grant <= Grant and grant_latch; 
+ port_grant <= grant_latch; 
  Grant(1)  <= Signal_grant(1)(1) or Signal_grant(16)(1); --  Grant(1,1)
 Grant(2)  <= Signal_grant(2)(2) or Signal_grant(17)(2); --  Grant(1,2)
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER16_16.VHD
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER16_16.VHD	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SCHEDULER16_16.VHD	(revision 65)
@@ -55,9 +55,10 @@
  signal grant_latch : std_logic_vector(256 downto 1); 
  signal priority_rotation_en : std_logic; 
- signal Grant :  std_logic_vector(256 downto 1);
+ signal Grant,req_grant :  std_logic_vector(256 downto 1);
  begin
 
---validation de la rotation de priorité lorsque aucun port n'emet 
- priority_rotation_en <= '1' when unsigned(priority_rotation) = 65535 else 	'0'; 
+--validation de la rotation de priorité lorsque aucun port n'emet
+req_grant<=(request and grant_latch); 
+ priority_rotation_en <= '1' when unsigned(req_grant) = 0 or unsigned(priority_rotation) = 65535 else 	'0'; 
 --latch servant qui memorise le signal grant pendant a transmission 
 grant_latch_process : process(clk)
@@ -66,10 +67,10 @@
    if reset = '1' then 
  		grant_latch <= (others => '0'); 
- 	 elsif priority_rotation_en = '1' then 
+ 	 elsif priority_rotation_en = '1' or unsigned(Grant_latch)=0  then 
 	   grant_latch <= Grant; 
    end if; 
    end if; 
  end process; 
- port_grant <= Grant and grant_latch; 
+ port_grant <= grant_latch; 
  Grant(1)  <= Signal_grant(1)(1) or Signal_grant(17)(1); --  Grant(1,1)
 Grant(2)  <= Signal_grant(2)(2) or Signal_grant(18)(2); --  Grant(1,2)
Index: PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SWITCH_GEN.vhd
===================================================================
--- PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SWITCH_GEN.vhd	(revision 45)
+++ PROJECT_CORE_MPI/SWITCH_GEN/BRANCHES/v0.03/SWITCH_GEN.vhd	(revision 65)
@@ -32,43 +32,13 @@
 entity SWITCH_GEN is 
  --type portio is array(positive range) of std_logic_vector (7 downto 0);    
- generic(number_of_ports : positive := 4);
+ generic(number_of_ports : positive := 8);
      port(
 	        -- ports d'entree
            Port_in : in typ_portIO(1 to number_of_ports) ;
---			  Port1_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port2_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port3_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port4_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---			  Port5_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port6_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port7_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port8_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---			  Port9_in : in  STD_LOGIC_VECTOR  (7 downto 0);
---           Port10_in : in  STD_LOGIC_VECTOR (7 downto 0);
---           Port11_in : in  STD_LOGIC_VECTOR (7 downto 0);
---           Port12_in : in  STD_LOGIC_VECTOR (7 downto 0);
---			  Port13_in : in  STD_LOGIC_VECTOR (7 downto 0);
---           Port14_in : in  STD_LOGIC_VECTOR (7 downto 0);
---           Port15_in : in  STD_LOGIC_VECTOR (7 downto 0);
---           Port16_in : in  STD_LOGIC_VECTOR (7 downto 0);
+
 			 
 			  -- port de sortie
 			  Port_out : out  typ_portIO(1 to number_of_ports);
---			  Port1_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port2_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port3_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port4_out : out  STD_LOGIC_VECTOR (7 downto 0);
---			  Port5_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port6_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port7_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port8_out : out  STD_LOGIC_VECTOR (7 downto 0);
---			  Port9_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port10_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port11_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port12_out : out  STD_LOGIC_VECTOR (7 downto 0);
---			  Port13_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port14_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port15_out : out  STD_LOGIC_VECTOR (7 downto 0);
---           Port16_out : out  STD_LOGIC_VECTOR (7 downto 0);
+
 			  -- signaux de controle
 			  data_in_en : in std_logic_vector(number_of_ports downto 1);
@@ -87,5 +57,5 @@
 
 COMPONENT INPUT_PORT_MODULE
-  generic(number_of_ports : positive := 4;
+  generic(number_of_ports : positive := 8;
 			Port_num: natural);
     Port ( data_in : in  STD_LOGIC_VECTOR (7 downto 0);
@@ -125,6 +95,7 @@
 			);
     Port ( 
-	        --Port_in : in Typ_PortIO(1 to number_of_crossbar_ports);
-			  Port1_in : in  STD_LOGIC_VECTOR (7 downto 0);
+	        clk : in  STD_LOGIC;
+			reset : in  STD_LOGIC;
+			Port1_in : in  STD_LOGIC_VECTOR (7 downto 0);
            Port2_in : in  STD_LOGIC_VECTOR (7 downto 0);
            Port3_in : in  STD_LOGIC_VECTOR (7 downto 0);
@@ -213,14 +184,4 @@
 
 --declaration des signaux de connection entre les modules du switch
---type port_connection_type is array(16 downto 1) of std_logic_vector(7 downto 1);
---signal crossbar_port_in_connetion : port_connection_type;
---signal crossbar_port_out_connetion :port_connection_type;
---signal request_connection : std_logic_vector(number_of_ports*number_of_ports downto 1);
---signal grant_connection : std_logic_vector(number_of_ports*number_of_ports downto 1);
---signal priority_rotation_connection : std_logic_vector(number_of_ports downto 1);
---signal fifo_out_full_connection : std_logic_vector(1 to number_of_ports);
---signal crossbar_in_pulse(_connection : std_logic_vector(number_of_ports downto 1);
---signal crossbar_out_pulse_connection : std_logic_vector(number_of_ports downto 1);
---variable i,j : integer;
 
 Signal Request_signal : STD_LOGIC_VECTOR(number_of_ports*number_of_ports downto 1);
@@ -231,74 +192,14 @@
 signal crossbar_in_port :  Typ_PortIO(1 to number_of_ports);
 
---signal crossbar_in_port1 : std_logic_vector(7 downto 0);
---signal crossbar_in_port2 : std_logic_vector(7 downto 0);
---signal crossbar_in_port3 : std_logic_vector(7 downto 0);
---signal crossbar_in_port4 : std_logic_vector(7 downto 0);
---signal crossbar_in_port5 : std_logic_vector(7 downto 0);
---signal crossbar_in_port6 : std_logic_vector(7 downto 0);
---signal crossbar_in_port7 : std_logic_vector(7 downto 0);
---signal crossbar_in_port8 : std_logic_vector(7 downto 0);
---signal crossbar_in_port9 : std_logic_vector(7 downto 0);
---signal crossbar_in_port10 : std_logic_vector(7 downto 0);
---signal crossbar_in_port11 : std_logic_vector(7 downto 0);
---signal crossbar_in_port12 : std_logic_vector(7 downto 0);
---signal crossbar_in_port13 : std_logic_vector(7 downto 0);
---signal crossbar_in_port14 : std_logic_vector(7 downto 0);
---signal crossbar_in_port15 : std_logic_vector(7 downto 0);
---signal crossbar_in_port16 : std_logic_vector(7 downto 0);
+
 
 signal crossbar_out_port  :  Typ_PortIO(1 to number_of_ports);
---signal crossbar_out_port1 : std_logic_vector(7 downto 0);
---signal crossbar_out_port2 : std_logic_vector(7 downto 0);
---signal crossbar_out_port3 : std_logic_vector(7 downto 0);
---signal crossbar_out_port4 : std_logic_vector(7 downto 0);
---signal crossbar_out_port5 : std_logic_vector(7 downto 0);
---signal crossbar_out_port6 : std_logic_vector(7 downto 0);
---signal crossbar_out_port7 : std_logic_vector(7 downto 0);
---signal crossbar_out_port8 : std_logic_vector(7 downto 0);
---signal crossbar_out_port9 : std_logic_vector(7 downto 0);
---signal crossbar_out_port10 : std_logic_vector(7 downto 0);
---signal crossbar_out_port11 : std_logic_vector(7 downto 0);
---signal crossbar_out_port12 : std_logic_vector(7 downto 0);
---signal crossbar_out_port13 : std_logic_vector(7 downto 0);
---signal crossbar_out_port14 : std_logic_vector(7 downto 0);
---signal crossbar_out_port15 : std_logic_vector(7 downto 0);
---signal crossbar_out_port16 : std_logic_vector(7 downto 0);
+
 
 signal crossbar_in_pulse  : std_logic_vector(number_of_ports downto 1);
---signal crossbar_in_pulse1 : std_logic;
---signal crossbar_in_pulse2 : std_logic;
---signal crossbar_in_pulse3 : std_logic;
---signal crossbar_in_pulse4 : std_logic;
---signal crossbar_in_pulse5 : std_logic;
---signal crossbar_in_pulse6 : std_logic;
---signal crossbar_in_pulse7 : std_logic;
---signal crossbar_in_pulse8 : std_logic;
---signal crossbar_in_pulse9 : std_logic;
---signal crossbar_in_pulse10 : std_logic;
---signal crossbar_in_pulse11 : std_logic;
---signal crossbar_in_pulse12 : std_logic;
---signal crossbar_in_pulse13 : std_logic;
---signal crossbar_in_pulse14 : std_logic;
---signal crossbar_in_pulse15 : std_logic;
---signal crossbar_in_pulse16 : std_logic;
+
 
 signal crossbar_out_pulse  : std_logic_vector(number_of_ports downto 1);
---signal crossbar_out_pulse1 : std_logic;
---signal crossbar_out_pulse2 : std_logic;
---signal crossbar_out_pulse3 : std_logic;
---signal crossbar_out_pulse4 : std_logic;
---signal crossbar_out_pulse5 : std_logic;
---signal crossbar_out_pulse6 : std_logic;
---signal crossbar_out_pulse7 : std_logic;
---signal crossbar_out_pulse8 : std_logic;
---signal crossbar_out_pulse9 : std_logic;
---signal crossbar_out_pulse10 : std_logic;
---signal crossbar_out_pulse11 : std_logic;
---signal crossbar_out_pulse12 : std_logic;
---signal crossbar_out_pulse13 : std_logic;
---signal crossbar_out_pulse14 : std_logic;
---signal crossbar_out_pulse15 : std_logic;
---signal crossbar_out_pulse16 : std_logic;
+
 
 
@@ -428,5 +329,5 @@
 --j=number_of_ports*(i-1);
 PORTx4_INPUT_PORT_MODULE: INPUT_PORT_MODULE 
-GENERIC MAP(number_of_ports =>4,Port_num=>i)
+GENERIC MAP(number_of_ports =>number_of_ports,Port_num=>i)
 PORT MAP(
    data_in => Port_in(i),
@@ -6281,4 +6182,6 @@
 GENERIC MAP(number_of_crossbar_ports =>2)
   PORT MAP(
+		reset => reset,
+     clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6327,5 +6230,7 @@
 GENERIC MAP(number_of_crossbar_ports =>3)
   PORT MAP(
-   Port1_in => crossbar_in_port(1),
+		reset => reset,
+     clk => clk, 
+	Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
    Port3_in => crossbar_in_port(3),
@@ -6375,4 +6280,6 @@
 GENERIC MAP(number_of_crossbar_ports =>4)
   PORT MAP(
+		reset => reset,
+     clk => clk,  
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6425,4 +6332,6 @@
 GENERIC MAP(number_of_crossbar_ports =>5)
   PORT MAP(
+		reset => reset,
+     clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6477,4 +6386,7 @@
 GENERIC MAP(number_of_crossbar_ports =>6)
   PORT MAP(
+  
+ 		reset => reset,
+     clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6531,4 +6443,6 @@
 GENERIC MAP(number_of_crossbar_ports =>7)
   PORT MAP(
+		reset => reset,
+     clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6587,4 +6501,6 @@
 GENERIC MAP(number_of_crossbar_ports =>8)
   PORT MAP(
+    reset => reset,
+   clk =>clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6645,4 +6561,6 @@
 GENERIC MAP(number_of_crossbar_ports =>9)
   PORT MAP(
+		reset => reset,
+     clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6705,4 +6623,6 @@
 GENERIC MAP(number_of_crossbar_ports =>10)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6767,4 +6687,6 @@
 GENERIC MAP(number_of_crossbar_ports =>11)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6831,4 +6753,6 @@
 GENERIC MAP(number_of_crossbar_ports =>12)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6897,4 +6821,6 @@
 GENERIC MAP(number_of_crossbar_ports =>13)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -6965,4 +6891,6 @@
 GENERIC MAP(number_of_crossbar_ports =>14)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -7035,4 +6963,6 @@
 GENERIC MAP(number_of_crossbar_ports =>15)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
@@ -7107,4 +7037,6 @@
 GENERIC MAP(number_of_crossbar_ports =>16)
   PORT MAP(
+	reset => reset,
+   clk => clk,
    Port1_in => crossbar_in_port(1),
    Port2_in => crossbar_in_port(2),
